diff --git a/dlls/winegstreamer/main.c b/dlls/winegstreamer/main.c
index d88a462d8..219fde82d 100644
--- a/dlls/winegstreamer/main.c
+++ b/dlls/winegstreamer/main.c
@@ -25,9 +25,7 @@
 #include "gst_private.h"
 #include "winternl.h"
 #include "rpcproxy.h"
-#include "dmoreg.h"
 #include "gst_guids.h"
-#include "wmcodecdsp.h"
 
 static unixlib_handle_t unix_handle;
 
@@ -70,20 +68,13 @@ struct wg_parser *wg_parser_create(enum wg_parser_type type, bool unlimited_buff
         .unlimited_buffering = unlimited_buffering,
     };
 
-    TRACE("type %#x, unlimited_buffering %d.\n", type, unlimited_buffering);
-
     if (__wine_unix_call(unix_handle, unix_wg_parser_create, &params))
         return NULL;
-
-    TRACE("Returning parser %p.\n", params.parser);
-
     return params.parser;
 }
 
 void wg_parser_destroy(struct wg_parser *parser)
 {
-    TRACE("parser %p.\n", parser);
-
     __wine_unix_call(unix_handle, unix_wg_parser_destroy, parser);
 }
 
@@ -95,15 +86,26 @@ HRESULT wg_parser_connect(struct wg_parser *parser, uint64_t file_size)
         .file_size = file_size,
     };
 
-    TRACE("parser %p, file_size %I64u.\n", parser, file_size);
-
     return __wine_unix_call(unix_handle, unix_wg_parser_connect, &params);
 }
 
-void wg_parser_disconnect(struct wg_parser *parser)
+HRESULT wg_parser_connect_unseekable(struct wg_parser *parser, const struct wg_format *in_format,
+        uint32_t stream_count, const struct wg_format *out_formats, const struct wg_rect *apertures)
 {
-    TRACE("parser %p.\n", parser);
+    struct wg_parser_connect_unseekable_params params =
+    {
+        .parser = parser,
+        .in_format = in_format,
+        .stream_count = stream_count,
+        .out_formats = out_formats,
+        .apertures = apertures,
+    };
+
+    return __wine_unix_call(unix_handle, unix_wg_parser_connect_unseekable, &params);
+}
 
+void wg_parser_disconnect(struct wg_parser *parser)
+{
     __wine_unix_call(unix_handle, unix_wg_parser_disconnect, parser);
 }
 
@@ -114,8 +116,6 @@ bool wg_parser_get_next_read_offset(struct wg_parser *parser, uint64_t *offset,
         .parser = parser,
     };
 
-    TRACE("parser %p, offset %p, size %p.\n", parser, offset, size);
-
     if (__wine_unix_call(unix_handle, unix_wg_parser_get_next_read_offset, &params))
         return false;
     *offset = params.offset;
@@ -123,17 +123,16 @@ bool wg_parser_get_next_read_offset(struct wg_parser *parser, uint64_t *offset,
     return true;
 }
 
-void wg_parser_push_data(struct wg_parser *parser, const void *data, uint32_t size)
+void wg_parser_push_data(struct wg_parser *parser, enum wg_read_result result, const void *data, uint32_t size)
 {
     struct wg_parser_push_data_params params =
     {
         .parser = parser,
+        .result = result,
         .data = data,
         .size = size,
     };
 
-    TRACE("parser %p, data %p, size %u.\n", parser, data, size);
-
     __wine_unix_call(unix_handle, unix_wg_parser_push_data, &params);
 }
 
@@ -144,8 +143,6 @@ uint32_t wg_parser_get_stream_count(struct wg_parser *parser)
         .parser = parser,
     };
 
-    TRACE("parser %p.\n", parser);
-
     __wine_unix_call(unix_handle, unix_wg_parser_get_stream_count, &params);
     return params.count;
 }
@@ -158,11 +155,7 @@ struct wg_parser_stream *wg_parser_get_stream(struct wg_parser *parser, uint32_t
         .index = index,
     };
 
-    TRACE("parser %p, index %u.\n", parser, index);
-
     __wine_unix_call(unix_handle, unix_wg_parser_get_stream, &params);
-
-    TRACE("Returning stream %p.\n", params.stream);
     return params.stream;
 }
 
@@ -174,28 +167,24 @@ void wg_parser_stream_get_preferred_format(struct wg_parser_stream *stream, stru
         .format = format,
     };
 
-    TRACE("stream %p, format %p.\n", stream, format);
-
     __wine_unix_call(unix_handle, unix_wg_parser_stream_get_preferred_format, &params);
 }
 
-void wg_parser_stream_enable(struct wg_parser_stream *stream, const struct wg_format *format)
+void wg_parser_stream_enable(struct wg_parser_stream *stream, const struct wg_format *format, const struct wg_rect *aperture, uint32_t flags)
 {
     struct wg_parser_stream_enable_params params =
     {
         .stream = stream,
         .format = format,
+        .aperture = aperture,
+        .flags = flags,
     };
 
-    TRACE("stream %p, format %p.\n", stream, format);
-
     __wine_unix_call(unix_handle, unix_wg_parser_stream_enable, &params);
 }
 
 void wg_parser_stream_disable(struct wg_parser_stream *stream)
 {
-    TRACE("stream %p.\n", stream);
-
     __wine_unix_call(unix_handle, unix_wg_parser_stream_disable, stream);
 }
 
@@ -207,8 +196,6 @@ bool wg_parser_stream_get_buffer(struct wg_parser_stream *stream, struct wg_pars
         .buffer = buffer,
     };
 
-    TRACE("stream %p, buffer %p.\n", stream, buffer);
-
     return !__wine_unix_call(unix_handle, unix_wg_parser_stream_get_buffer, &params);
 }
 
@@ -223,15 +210,11 @@ bool wg_parser_stream_copy_buffer(struct wg_parser_stream *stream,
         .size = size,
     };
 
-    TRACE("stream %p, data %p, offset %u, size %u.\n", stream, data, offset, size);
-
     return !__wine_unix_call(unix_handle, unix_wg_parser_stream_copy_buffer, &params);
 }
 
 void wg_parser_stream_release_buffer(struct wg_parser_stream *stream)
 {
-    TRACE("stream %p.\n", stream);
-
     __wine_unix_call(unix_handle, unix_wg_parser_stream_release_buffer, stream);
 }
 
@@ -247,9 +230,6 @@ void wg_parser_stream_notify_qos(struct wg_parser_stream *stream,
         .timestamp = timestamp,
     };
 
-    TRACE("stream %p, underflow %d, proportion %.16e, diff %I64d, timestamp %I64u.\n",
-            stream, underflow, proportion, diff, timestamp);
-
     __wine_unix_call(unix_handle, unix_wg_parser_stream_notify_qos, &params);
 }
 
@@ -260,14 +240,22 @@ uint64_t wg_parser_stream_get_duration(struct wg_parser_stream *stream)
         .stream = stream,
     };
 
-    TRACE("stream %p.\n", stream);
-
     __wine_unix_call(unix_handle, unix_wg_parser_stream_get_duration, &params);
-
-    TRACE("Returning duration %I64u.\n", params.duration);
     return params.duration;
 }
 
+bool wg_parser_stream_get_language(struct wg_parser_stream *stream, char *buffer, uint32_t size)
+{
+    struct wg_parser_stream_get_language_params params =
+    {
+        .stream = stream,
+        .buffer = buffer,
+        .size = size,
+    };
+
+    return !__wine_unix_call(unix_handle, unix_wg_parser_stream_get_language, &params);
+}
+
 void wg_parser_stream_seek(struct wg_parser_stream *stream, double rate,
         uint64_t start_pos, uint64_t stop_pos, DWORD start_flags, DWORD stop_flags)
 {
@@ -281,13 +269,15 @@ void wg_parser_stream_seek(struct wg_parser_stream *stream, double rate,
         .stop_flags = stop_flags,
     };
 
-    TRACE("stream %p, rate %.16e, start_pos %I64u, stop_pos %I64u, start_flags %#lx, stop_flags %#lx.\n",
-            stream, rate, start_pos, stop_pos, start_flags, stop_flags);
-
     __wine_unix_call(unix_handle, unix_wg_parser_stream_seek, &params);
 }
 
-struct wg_transform *wg_transform_create(const struct wg_format *input_format,
+bool wg_parser_stream_drain(struct wg_parser_stream *stream)
+{
+    return !__wine_unix_call(unix_handle, unix_wg_parser_stream_drain, stream);
+}
+
+struct wg_transform *wg_transform_create(const struct wg_encoded_format *input_format,
         const struct wg_format *output_format)
 {
     struct wg_transform_create_params params =
@@ -296,37 +286,26 @@ struct wg_transform *wg_transform_create(const struct wg_format *input_format,
         .output_format = output_format,
     };
 
-    TRACE("input_format %p, output_format %p.\n", input_format, output_format);
-
     if (__wine_unix_call(unix_handle, unix_wg_transform_create, &params))
         return NULL;
-
-    TRACE("Returning transform %p.\n", params.transform);
     return params.transform;
 }
 
 void wg_transform_destroy(struct wg_transform *transform)
 {
-    TRACE("transform %p.\n", transform);
-
     __wine_unix_call(unix_handle, unix_wg_transform_destroy, transform);
 }
 
-HRESULT wg_transform_push_data(struct wg_transform *transform, struct wg_sample *sample)
+HRESULT wg_transform_push_data(struct wg_transform *transform, const void *data, uint32_t size)
 {
     struct wg_transform_push_data_params params =
     {
         .transform = transform,
-        .sample = sample,
+        .data = data,
+        .size = size,
     };
-    NTSTATUS status;
-
-    TRACE("transform %p, sample %p.\n", transform, sample);
-
-    if ((status = __wine_unix_call(unix_handle, unix_wg_transform_push_data, &params)))
-        return HRESULT_FROM_NT(status);
 
-    return params.result;
+    return __wine_unix_call(unix_handle, unix_wg_transform_push_data, &params);
 }
 
 HRESULT wg_transform_read_data(struct wg_transform *transform, struct wg_sample *sample)
@@ -336,14 +315,8 @@ HRESULT wg_transform_read_data(struct wg_transform *transform, struct wg_sample
         .transform = transform,
         .sample = sample,
     };
-    NTSTATUS status;
 
-    TRACE("transform %p, sample %p.\n", transform, sample);
-
-    if ((status = __wine_unix_call(unix_handle, unix_wg_transform_read_data, &params)))
-        return HRESULT_FROM_NT(status);
-
-    return params.result;
+    return __wine_unix_call(unix_handle, unix_wg_transform_read_data, &params);
 }
 
 BOOL WINAPI DllMain(HINSTANCE instance, DWORD reason, void *reserved)
@@ -619,24 +592,16 @@ static const REGFILTER2 reg_decodebin_parser =
 
 HRESULT WINAPI DllRegisterServer(void)
 {
-    DMO_PARTIAL_MEDIATYPE wma_decoder_output[2] =
-    {
-        {.type = MEDIATYPE_Audio, .subtype = MEDIASUBTYPE_PCM},
-        {.type = MEDIATYPE_Audio, .subtype = MEDIASUBTYPE_IEEE_FLOAT},
-    };
-    DMO_PARTIAL_MEDIATYPE wma_decoder_input[4] =
-    {
-        {.type = MEDIATYPE_Audio, .subtype = MEDIASUBTYPE_MSAUDIO1},
-        {.type = MEDIATYPE_Audio, .subtype = MEDIASUBTYPE_WMAUDIO2},
-        {.type = MEDIATYPE_Audio, .subtype = MEDIASUBTYPE_WMAUDIO3},
-        {.type = MEDIATYPE_Audio, .subtype = MEDIASUBTYPE_WMAUDIO_LOSSLESS},
-    };
-
     IFilterMapper2 *mapper;
     HRESULT hr;
 
     TRACE(".\n");
 
+    init_gstreamer();
+
+    if (FAILED(hr = mfplat_DllRegisterServer()))
+        return hr;
+
     if (FAILED(hr = __wine_register_resources()))
         return hr;
 
@@ -653,10 +618,6 @@ HRESULT WINAPI DllRegisterServer(void)
 
     IFilterMapper2_Release(mapper);
 
-    if (FAILED(hr = DMORegister(L"WMA Decoder DMO", &CLSID_WMADecMediaObject, &DMOCATEGORY_AUDIO_DECODER,
-            0, ARRAY_SIZE(wma_decoder_input), wma_decoder_input, ARRAY_SIZE(wma_decoder_output), wma_decoder_output)))
-        return hr;
-
     return mfplat_DllRegisterServer();
 }
 
@@ -680,9 +641,5 @@ HRESULT WINAPI DllUnregisterServer(void)
     IFilterMapper2_UnregisterFilter(mapper, NULL, NULL, &CLSID_WAVEParser);
 
     IFilterMapper2_Release(mapper);
-
-    if (FAILED(hr = DMOUnregister(&CLSID_WMADecMediaObject, &DMOCATEGORY_AUDIO_DECODER)))
-        return hr;
-
     return S_OK;
 }
diff --git a/dlls/winegstreamer/media_source.c b/dlls/winegstreamer/media_source.c
index f07b83f41..82a6da1bc 100644
--- a/dlls/winegstreamer/media_source.c
+++ b/dlls/winegstreamer/media_source.c
@@ -105,7 +105,6 @@ struct media_source
         SOURCE_RUNNING,
         SOURCE_SHUTDOWN,
     } state;
-    float rate;
 
     HANDLE read_thread;
     bool read_thread_shutdown;
@@ -305,7 +304,7 @@ static void flush_token_queue(struct media_stream *stream, BOOL send)
                         &stream->parent_source->async_commands_callback, &command->IUnknown_iface);
             }
             if (FAILED(hr))
-                WARN("Could not enqueue sample request, hr %#lx\n", hr);
+                WARN("Could not enqueue sample request, hr %#x\n", hr);
         }
         else if (stream->token_queue[i])
             IUnknown_Release(stream->token_queue[i]);
@@ -358,15 +357,11 @@ static void start_pipeline(struct media_source *source, struct source_async_comm
             IMFMediaTypeHandler_GetCurrentMediaType(mth, &current_mt);
 
             mf_media_type_to_wg_format(current_mt, &format);
-            wg_parser_stream_enable(stream->wg_stream, &format);
+            wg_parser_stream_enable(stream->wg_stream, &format, NULL, 0);
 
             IMFMediaType_Release(current_mt);
             IMFMediaTypeHandler_Release(mth);
         }
-        else
-        {
-            wg_parser_stream_disable(stream->wg_stream);
-        }
 
         if (position->vt != VT_EMPTY)
             stream->eos = FALSE;
@@ -423,7 +418,10 @@ static void stop_pipeline(struct media_source *source)
     {
         struct media_stream *stream = source->streams[i];
         if (stream->state != STREAM_INACTIVE)
+        {
             IMFMediaEventQueue_QueueEventParamVar(stream->event_queue, MEStreamStopped, &GUID_NULL, S_OK, NULL);
+            wg_parser_stream_disable(stream->wg_stream);
+        }
     }
 
     IMFMediaEventQueue_QueueEventParamVar(source->event_queue, MESourceStopped, &GUID_NULL, S_OK, NULL);
@@ -460,32 +458,32 @@ static void send_buffer(struct media_stream *stream, const struct wg_parser_buff
 
     if (FAILED(hr = MFCreateSample(&sample)))
     {
-        ERR("Failed to create sample, hr %#lx.\n", hr);
+        ERR("Failed to create sample, hr %#x.\n", hr);
         return;
     }
 
     if (FAILED(hr = MFCreateMemoryBuffer(wg_buffer->size, &buffer)))
     {
-        ERR("Failed to create buffer, hr %#lx.\n", hr);
+        ERR("Failed to create buffer, hr %#x.\n", hr);
         IMFSample_Release(sample);
         return;
     }
 
     if (FAILED(hr = IMFSample_AddBuffer(sample, buffer)))
     {
-        ERR("Failed to add buffer, hr %#lx.\n", hr);
+        ERR("Failed to add buffer, hr %#x.\n", hr);
         goto out;
     }
 
     if (FAILED(hr = IMFMediaBuffer_SetCurrentLength(buffer, wg_buffer->size)))
     {
-        ERR("Failed to set size, hr %#lx.\n", hr);
+        ERR("Failed to set size, hr %#x.\n", hr);
         goto out;
     }
 
     if (FAILED(hr = IMFMediaBuffer_Lock(buffer, &data, NULL, NULL)))
     {
-        ERR("Failed to lock buffer, hr %#lx.\n", hr);
+        ERR("Failed to lock buffer, hr %#x.\n", hr);
         goto out;
     }
 
@@ -499,19 +497,19 @@ static void send_buffer(struct media_stream *stream, const struct wg_parser_buff
 
     if (FAILED(hr = IMFMediaBuffer_Unlock(buffer)))
     {
-        ERR("Failed to unlock buffer, hr %#lx.\n", hr);
+        ERR("Failed to unlock buffer, hr %#x.\n", hr);
         goto out;
     }
 
     if (FAILED(hr = IMFSample_SetSampleTime(sample, wg_buffer->pts)))
     {
-        ERR("Failed to set sample time, hr %#lx.\n", hr);
+        ERR("Failed to set sample time, hr %#x.\n", hr);
         goto out;
     }
 
     if (FAILED(hr = IMFSample_SetSampleDuration(sample, wg_buffer->duration)))
     {
-        ERR("Failed to set sample duration, hr %#lx.\n", hr);
+        ERR("Failed to set sample duration, hr %#x.\n", hr);
         goto out;
     }
 
@@ -626,7 +624,7 @@ static DWORD CALLBACK read_thread(void *arg)
          * an error when reading past the file size. */
         if (!size)
         {
-            wg_parser_push_data(source->wg_parser, data, 0);
+            wg_parser_push_data(source->wg_parser, WG_READ_SUCCESS, data, 0);
             continue;
         }
 
@@ -641,10 +639,10 @@ static DWORD CALLBACK read_thread(void *arg)
         if (SUCCEEDED(hr = IMFByteStream_SetCurrentPosition(byte_stream, offset)))
             hr = IMFByteStream_Read(byte_stream, data, size, &ret_size);
         if (FAILED(hr))
-            ERR("Failed to read %u bytes at offset %I64u, hr %#lx.\n", size, offset, hr);
+            ERR("Failed to read %u bytes at offset %I64u, hr %#x.\n", size, offset, hr);
         else if (ret_size != size)
-            ERR("Unexpected short read: requested %u bytes, got %lu.\n", size, ret_size);
-        wg_parser_push_data(source->wg_parser, SUCCEEDED(hr) ? data : NULL, ret_size);
+            ERR("Unexpected short read: requested %u bytes, got %u.\n", size, ret_size);
+        wg_parser_push_data(source->wg_parser, SUCCEEDED(hr) ? WG_READ_SUCCESS : WG_READ_FAILURE, data, ret_size);
     }
 
     free(data);
@@ -680,7 +678,7 @@ static ULONG WINAPI media_stream_AddRef(IMFMediaStream *iface)
     struct media_stream *stream = impl_from_IMFMediaStream(iface);
     ULONG ref = InterlockedIncrement(&stream->ref);
 
-    TRACE("%p, refcount %lu.\n", iface, ref);
+    TRACE("%p, refcount %u.\n", iface, ref);
 
     return ref;
 }
@@ -690,7 +688,7 @@ static ULONG WINAPI media_stream_Release(IMFMediaStream *iface)
     struct media_stream *stream = impl_from_IMFMediaStream(iface);
     ULONG ref = InterlockedDecrement(&stream->ref);
 
-    TRACE("%p, refcount %lu.\n", iface, ref);
+    TRACE("%p, refcount %u.\n", iface, ref);
 
     if (!ref)
     {
@@ -707,7 +705,7 @@ static HRESULT WINAPI media_stream_GetEvent(IMFMediaStream *iface, DWORD flags,
 {
     struct media_stream *stream = impl_from_IMFMediaStream(iface);
 
-    TRACE("%p, %#lx, %p.\n", iface, flags, event);
+    TRACE("%p, %#x, %p.\n", iface, flags, event);
 
     return IMFMediaEventQueue_GetEvent(stream->event_queue, flags, event);
 }
@@ -735,7 +733,7 @@ static HRESULT WINAPI media_stream_QueueEvent(IMFMediaStream *iface, MediaEventT
 {
     struct media_stream *stream = impl_from_IMFMediaStream(iface);
 
-    TRACE("%p, %lu, %s, %#lx, %p.\n", iface, event_type, debugstr_guid(ext_type), hr, value);
+    TRACE("%p, %d, %s, %#x, %p.\n", iface, event_type, debugstr_guid(ext_type), hr, value);
 
     return IMFMediaEventQueue_QueueEventParamVar(stream->event_queue, event_type, ext_type, hr, value);
 }
@@ -826,7 +824,7 @@ static HRESULT new_media_stream(struct media_source *source,
     struct media_stream *object = calloc(1, sizeof(*object));
     HRESULT hr;
 
-    TRACE("source %p, wg_stream %p, stream_id %lu.\n", source, wg_stream, stream_id);
+    TRACE("source %p, wg_stream %p, stream_id %u.\n", source, wg_stream, stream_id);
 
     object->IMFMediaStream_iface.lpVtbl = &media_stream_vtbl;
     object->ref = 1;
@@ -855,7 +853,7 @@ static HRESULT new_media_stream(struct media_source *source,
 static HRESULT media_stream_init_desc(struct media_stream *stream)
 {
     IMFMediaTypeHandler *type_handler = NULL;
-    IMFMediaType *stream_types[6];
+    IMFMediaType *stream_types[8];
     struct wg_format format;
     DWORD type_count = 0;
     unsigned int i;
@@ -874,6 +872,8 @@ static HRESULT media_stream_init_desc(struct media_stream *stream)
             &MFVideoFormat_YUY2,
             &MFVideoFormat_IYUV,
             &MFVideoFormat_I420,
+            &MFVideoFormat_ARGB32,
+            &MFVideoFormat_RGB32,
         };
 
         IMFMediaType *base_type = mf_media_type_from_wg_format(&format);
@@ -1092,9 +1092,6 @@ static ULONG WINAPI media_source_rate_control_Release(IMFRateControl *iface)
 
 static HRESULT WINAPI media_source_rate_control_SetRate(IMFRateControl *iface, BOOL thin, float rate)
 {
-    struct media_source *source = impl_from_IMFRateControl(iface);
-    HRESULT hr;
-
     FIXME("%p, %d, %f.\n", iface, thin, rate);
 
     if (rate < 0.0f)
@@ -1103,24 +1100,20 @@ static HRESULT WINAPI media_source_rate_control_SetRate(IMFRateControl *iface, B
     if (thin)
         return MF_E_THINNING_UNSUPPORTED;
 
-    if (FAILED(hr = IMFRateSupport_IsRateSupported(&source->IMFRateSupport_iface, thin, rate, NULL)))
-        return hr;
-
-    source->rate = rate;
+    if (rate != 1.0f)
+        return MF_E_UNSUPPORTED_RATE;
 
-    return IMFMediaEventQueue_QueueEventParamVar(source->event_queue, MESourceRateChanged, &GUID_NULL, S_OK, NULL);
+    return S_OK;
 }
 
 static HRESULT WINAPI media_source_rate_control_GetRate(IMFRateControl *iface, BOOL *thin, float *rate)
 {
-    struct media_source *source = impl_from_IMFRateControl(iface);
-
     TRACE("%p, %p, %p.\n", iface, thin, rate);
 
     if (thin)
         *thin = FALSE;
 
-    *rate = source->rate;
+    *rate = 1.0f;
 
     return S_OK;
 }
@@ -1166,7 +1159,7 @@ static ULONG WINAPI media_source_AddRef(IMFMediaSource *iface)
     struct media_source *source = impl_from_IMFMediaSource(iface);
     ULONG ref = InterlockedIncrement(&source->ref);
 
-    TRACE("%p, refcount %lu.\n", iface, ref);
+    TRACE("%p, refcount %u.\n", iface, ref);
 
     return ref;
 }
@@ -1176,7 +1169,7 @@ static ULONG WINAPI media_source_Release(IMFMediaSource *iface)
     struct media_source *source = impl_from_IMFMediaSource(iface);
     ULONG ref = InterlockedDecrement(&source->ref);
 
-    TRACE("%p, refcount %lu.\n", iface, ref);
+    TRACE("%p, refcount %u.\n", iface, ref);
 
     if (!ref)
     {
@@ -1192,7 +1185,7 @@ static HRESULT WINAPI media_source_GetEvent(IMFMediaSource *iface, DWORD flags,
 {
     struct media_source *source = impl_from_IMFMediaSource(iface);
 
-    TRACE("%p, %#lx, %p.\n", iface, flags, event);
+    TRACE("%p, %#x, %p.\n", iface, flags, event);
 
     return IMFMediaEventQueue_GetEvent(source->event_queue, flags, event);
 }
@@ -1220,7 +1213,7 @@ static HRESULT WINAPI media_source_QueueEvent(IMFMediaSource *iface, MediaEventT
 {
     struct media_source *source = impl_from_IMFMediaSource(iface);
 
-    TRACE("%p, %lu, %s, %#lx, %p.\n", iface, event_type, debugstr_guid(ext_type), hr, value);
+    TRACE("%p, %d, %s, %#x, %p.\n", iface, event_type, debugstr_guid(ext_type), hr, value);
 
     return IMFMediaEventQueue_QueueEventParamVar(source->event_queue, event_type, ext_type, hr, value);
 }
@@ -1379,6 +1372,7 @@ static const IMFMediaSourceVtbl IMFMediaSource_vtbl =
 
 static HRESULT media_source_constructor(IMFByteStream *bytestream, struct media_source **out_media_source)
 {
+    BOOL video_selected = FALSE, audio_selected = FALSE;
     IMFStreamDescriptor **descriptors = NULL;
     unsigned int stream_count = UINT_MAX;
     struct media_source *object;
@@ -1400,7 +1394,7 @@ static HRESULT media_source_constructor(IMFByteStream *bytestream, struct media_
 
     if (FAILED(hr = IMFByteStream_GetLength(bytestream, &file_size)))
     {
-        FIXME("Failed to get byte stream length, hr %#lx.\n", hr);
+        FIXME("Failed to get byte stream length, hr %#x.\n", hr);
         return hr;
     }
 
@@ -1415,7 +1409,6 @@ static HRESULT media_source_constructor(IMFByteStream *bytestream, struct media_
     object->ref = 1;
     object->byte_stream = bytestream;
     IMFByteStream_AddRef(bytestream);
-    object->rate = 1.0f;
 
     if (FAILED(hr = MFCreateEventQueue(&object->event_queue)))
         goto fail;
@@ -1458,7 +1451,7 @@ static HRESULT media_source_constructor(IMFByteStream *bytestream, struct media_
 
         if (FAILED(hr = media_stream_init_desc(object->streams[i])))
         {
-            ERR("Failed to finish initialization of media stream %p, hr %#lx.\n", object->streams[i], hr);
+            ERR("Failed to finish initialization of media stream %p, hr %x.\n", object->streams[i], hr);
             IMFMediaSource_Release(&object->streams[i]->parent_source->IMFMediaSource_iface);
             IMFMediaEventQueue_Release(object->streams[i]->event_queue);
             free(object->streams[i]);
@@ -1473,15 +1466,52 @@ static HRESULT media_source_constructor(IMFByteStream *bytestream, struct media_
     descriptors = malloc(object->stream_count * sizeof(IMFStreamDescriptor *));
     for (i = 0; i < object->stream_count; i++)
     {
-        IMFMediaStream_GetStreamDescriptor(&object->streams[i]->IMFMediaStream_iface, &descriptors[i]);
+        IMFStreamDescriptor **descriptor = &descriptors[object->stream_count - 1 - i];
+        char language[128];
+        DWORD language_len;
+        WCHAR *languageW;
+
+        IMFMediaStream_GetStreamDescriptor(&object->streams[i]->IMFMediaStream_iface, descriptor);
+
+        if (wg_parser_stream_get_language(object->streams[i]->wg_stream, language, sizeof(language)))
+        {
+            if ((language_len = MultiByteToWideChar(CP_UTF8, 0, language, -1, NULL, 0)))
+            {
+                languageW = malloc(language_len * sizeof(WCHAR));
+                if (MultiByteToWideChar(CP_UTF8, 0, language, -1, languageW, language_len))
+                {
+                    IMFStreamDescriptor_SetString(*descriptor, &MF_SD_LANGUAGE, languageW);
+                }
+                free(languageW);
+            }
+        }
     }
 
     if (FAILED(hr = MFCreatePresentationDescriptor(object->stream_count, descriptors, &object->pres_desc)))
         goto fail;
 
+    /* Select one of each major type. */
     for (i = 0; i < object->stream_count; i++)
     {
-        IMFPresentationDescriptor_SelectStream(object->pres_desc, i);
+        IMFMediaTypeHandler *handler;
+        GUID major_type;
+        BOOL select_stream = FALSE;
+
+        IMFStreamDescriptor_GetMediaTypeHandler(descriptors[i], &handler);
+        IMFMediaTypeHandler_GetMajorType(handler, &major_type);
+        if (IsEqualGUID(&major_type, &MFMediaType_Video) && !video_selected)
+        {
+            select_stream = TRUE;
+            video_selected = TRUE;
+        }
+        if (IsEqualGUID(&major_type, &MFMediaType_Audio) && !audio_selected)
+        {
+            select_stream = TRUE;
+            audio_selected = TRUE;
+        }
+        if (select_stream)
+            IMFPresentationDescriptor_SelectStream(object->pres_desc, i);
+        IMFMediaTypeHandler_Release(handler);
         IMFStreamDescriptor_Release(descriptors[i]);
     }
     free(descriptors);
@@ -1500,7 +1530,7 @@ static HRESULT media_source_constructor(IMFByteStream *bytestream, struct media_
     return S_OK;
 
     fail:
-    WARN("Failed to construct MFMediaSource, hr %#lx.\n", hr);
+    WARN("Failed to construct MFMediaSource, hr %#x.\n", hr);
 
     if (descriptors)
     {
@@ -1587,7 +1617,7 @@ static ULONG WINAPI winegstreamer_stream_handler_AddRef(IMFByteStreamHandler *if
     struct winegstreamer_stream_handler *handler = impl_from_IMFByteStreamHandler(iface);
     ULONG refcount = InterlockedIncrement(&handler->refcount);
 
-    TRACE("%p, refcount %lu.\n", handler, refcount);
+    TRACE("%p, refcount %u.\n", handler, refcount);
 
     return refcount;
 }
@@ -1598,7 +1628,7 @@ static ULONG WINAPI winegstreamer_stream_handler_Release(IMFByteStreamHandler *i
     ULONG refcount = InterlockedDecrement(&handler->refcount);
     struct winegstreamer_stream_handler_result *result, *next;
 
-    TRACE("%p, refcount %lu.\n", iface, refcount);
+    TRACE("%p, refcount %u.\n", iface, refcount);
 
     if (!refcount)
     {
@@ -1654,7 +1684,7 @@ static ULONG WINAPI create_object_context_AddRef(IUnknown *iface)
     struct create_object_context *context = impl_from_IUnknown(iface);
     ULONG refcount = InterlockedIncrement(&context->refcount);
 
-    TRACE("%p, refcount %lu.\n", iface, refcount);
+    TRACE("%p, refcount %u.\n", iface, refcount);
 
     return refcount;
 }
@@ -1664,7 +1694,7 @@ static ULONG WINAPI create_object_context_Release(IUnknown *iface)
     struct create_object_context *context = impl_from_IUnknown(iface);
     ULONG refcount = InterlockedDecrement(&context->refcount);
 
-    TRACE("%p, refcount %lu.\n", iface, refcount);
+    TRACE("%p, refcount %u.\n", iface, refcount);
 
     if (!refcount)
     {
@@ -1694,7 +1724,7 @@ static HRESULT WINAPI winegstreamer_stream_handler_BeginCreateObject(IMFByteStre
     IMFAsyncResult *caller, *item;
     HRESULT hr;
 
-    TRACE("%p, %s, %#lx, %p, %p, %p, %p.\n", iface, debugstr_w(url), flags, props, cancel_cookie, callback, state);
+    TRACE("%p, %s, %#x, %p, %p, %p, %p.\n", iface, debugstr_w(url), flags, props, cancel_cookie, callback, state);
 
     if (cancel_cookie)
         *cancel_cookie = NULL;
@@ -1871,7 +1901,7 @@ static HRESULT WINAPI winegstreamer_stream_handler_callback_GetParameters(IMFAsy
 static HRESULT winegstreamer_stream_handler_create_object(struct winegstreamer_stream_handler *This, WCHAR *url, IMFByteStream *stream, DWORD flags,
                                             IPropertyStore *props, IUnknown **out_object, MF_OBJECT_TYPE *out_obj_type)
 {
-    TRACE("%p, %s, %p, %#lx, %p, %p, %p.\n", This, debugstr_w(url), stream, flags, props, out_object, out_obj_type);
+    TRACE("%p, %s, %p, %u, %p, %p, %p.\n", This, debugstr_w(url), stream, flags, props, out_object, out_obj_type);
 
     if (flags & MF_RESOLUTION_MEDIASOURCE)
     {
@@ -1890,7 +1920,7 @@ static HRESULT winegstreamer_stream_handler_create_object(struct winegstreamer_s
     }
     else
     {
-        FIXME("Unhandled flags %#lx.\n", flags);
+        FIXME("flags = %08x\n", flags);
         return E_NOTIMPL;
     }
 }
